﻿Type=Service
Version=5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: True
#End Region

'Service module
Sub Process_Globals
    
	Dim sNotif As Notification
	Dim PE As PhoneEvents
	Dim PhoneId As PhoneId
	Dim Timer1 As Timer
	Dim AC As AnswerCall

	Dim lstBarred As List
	
End Sub
Sub Service_Create
	
	PE.InitializeWithPhoneState("PE",PhoneId)
	AC.Initialize("AnswerCall")

	sNotif.Initialize
	sNotif.Icon = "red_flag"
    sNotif.SetInfo("HangUp & POQ", "Monitoring for Telemaketing Calls ....",Main)
    sNotif.Sound = False
    sNotif.Notify(1)    
    Service.StartForeground(1,sNotif)
	
End Sub

Sub Service_Start
	
	'as list grows maybe look at utilizing and load numbers from file / db
	lstBarred.Initialize
	lstBarred.Clear
	lstBarred.Add ("02")
	lstBarred.Add ("03")
	lstBarred.Add ("07")
	lstBarred.Add ("5551234567")
	lstBarred.Add ("-1")  'number left by private number = "-2" .. thought to try -1

	ToastMessageShow("HangUp Service Started ...",False)
	
End Sub

Sub Service_Destroy

    ToastMessageShow("HangUp Service Stoped ...",False)
	
End Sub

Sub PE_PhoneStateChanged (State As String, IncomingNumber As String, Intent As Intent)
        
    Select State
        
		'Case "IDLE" ' Idle state.
                 
        Case "RINGING" ' Ringing state.
		
			'If IncomingNumber.SubString2(0,2) = "02" OR IncomingNumber.SubString2(0,2) = "07" OR IncomingNumber = "0399407777" OR IncomingNumber.Trim = "-2" Then
			
			Dim numBarred As String
			Dim lenBarred As Int 

			
			For  i = 0 To lstBarred.Size -1
				
				numBarred = lstBarred.Get(i)
				lenBarred = numBarred.Length  'length of barred number to match same length incomming number
				
				
				If IncomingNumber = Null Then				

					Msgbox ("Error #1 .. Incoming Number = Null " ,IncomingNumber)
				
				End If
				
				Try
     
					'loop thru the barred list .. trimming incomming number to match barred number length .. (allows barring all calls with certain prefix)
					If IncomingNumber.SubString2(0,lenBarred ) = numBarred Then
				
						AC.AnswerPhone
								
						'suggested to pause prior to hiding dialer again .. 
						'Ian ... on 3 secs Missed call notify and msg still processed .. 
   						Timer1.Initialize("Timer1", 4000) ' 1000 = 1 second
   						Timer1.Enabled = True

					End If							
         		
				Catch
      
	  				Msgbox ("Error #2 .. Incoming Number = " ,IncomingNumber)
   				
				End Try
			
			
			Next
			
		'Case "OFFHOOK" ' Off the hook state.
      
    End Select

End Sub

Sub Timer1_Tick	
	
	'hangup phone and disable timer
	KillCall

	Timer1.Enabled = False
	
	'remove call from logs .. doesn't seem to work with these numbers ? worked with home no...
	
	'DeleteCallLog
	
End Sub

Sub KillCall

    Dim r As Reflector
    r.Target = r.GetContext
    Dim TelephonyManager, TelephonyInterface As Object
    TelephonyManager = r.RunMethod2("getSystemService", "phone", "java.lang.String")
    r.Target = TelephonyManager
    TelephonyInterface = r.RunMethod("getITelephony")
    r.Target = TelephonyInterface
    r.RunMethod("endCall")
	
End Sub
	
Sub DeleteCallLog

	
	'#### cannot located library needed (MyFirstLib)
	
	'Dim MFL As MyFirstLib
	'Dim iStart,strRecord,iStop,numPhone As String	
	'Dim CallLog1 As CallLog
	'Dim LogList As List
  
	'LogList=CallLog1.GetAll(0)
    
	'For i =0 To LogList.Size-1 
    '	strRecord=LogList.Get(i)
             			 
	'	iStart=strRecord.IndexOf("Number=") + 7
    '    iStop=strRecord.IndexOf(",CachedName=")
    '    numPhone=strRecord.SubString2(iStart,iStop)
               			 						 				
		
	'	If numPhone.SubString2(0,2) = "02" Or numPhone.SubString2(0,2) = "07" Then
    '    	MFL.DeleteCallLogs(numPhone)                   
    '    End If
		
    'Next

End Sub





	